*:*****************************************************************************
*:
*:        Program: D:\PCFOX\PRGS\MSGBOX.PRG
*:         System: Windows/Mac ONLY
*:         Author: Jonathan Simmons 100025,2662
*:      Copyright (c) 29th March, 1994, Jonathan Simmons
*:  Last modified: 29/03/94 at 19:01:18
*:
*:      Documented 20:16:02                                FoxDoc version 3.00a
*:*****************************************************************************
* Nothing fancy with this code - just practical!
* Emulates (almost)in Mac version the behaviour of Windows foxtools msgbox() so as to allow
* the use of this function name in both platforms without any code changes.
*
* If too many read levels are in use, the function uses inkey() to create the 
* same effect but without the buttons and therefore in Mac version can be used
* in an identical manner to the Windows foxtools version.
*
* This function will wrap text onto three lines and will also accept CHR(13) 
* in the msg text string, eg 'Text on line 1'+chr(13)+'Text on line 2'
* 
* Usage:
*  MSGBOX(<exp1C>,<exp2C>,<expN>)
*  
*  Returns:
*	OK		1
*	CANCEL	2
*	ABORT	3
*	RETRY	4
*	IGNORE	5
*	YES		6
*	NO		7
*
*  Description:
*	<exp1C>	Contents of dialog box
*	<exp2C>	Title of dialog box window
*	<expN>	Type of dialog box as follows:
*
*	Buttons OK					0
*	Buttons OK CANCEL			1
*	Buttons ABORT RETRY IGNORE	2
*	Buttons YES NO CANCEL		3
*	Buttons YES NO				4
*	Buttons RETRY CANCEL		5
*	
*	Icon - STOP			16
*	Icon - QUESTION		32
*	Icon - EXCLAMATION	48
*	Icon - INFORMATION	64
*
*	Add button type to icon type, eg 34 = QUESTION with ABORT RETRY IGNORE
*	and 68 = INFORMATION with YES NO
*
*
*FUNCTION msgbox	&& enable this line to include in your function library
parameters msg,windowtitle,icontype
private msg,windowtitle,icontype,m.button,read_ok,hotkey,m.icon,m.b_type
read_ok=iif(rdlevel()<5,.t.,.f.)	&& if too many rdlevels use inkey() variation of function

hotkey=''
m.button=''
fontname=iif(_WINDOWS,"MS Sans Serif","Geneva")
clear typeahead
push key clear
define window msgbox at  0.000, 0.000 size 8.231,63.600 ;
 title windowtitle font fontname, 8 ;
 nofloat noclose nominimize system
move window msgbox center

if wvisible("msgbox")
 activate window msgbox same
else
 activate window msgbox noshow
endif

m.icon=int(icontype/16)			&& determine which icon to display
m.b_type=mod(icontype,16)		&& determine which button choices to display

do case							&& display relevant icon
case m.icon=1
 @ 1.154,1.800 say (locfile("stop.bmp","BMP|ICO", "Where is Stop?")) bitmap ;
  size 2.769,7.200 ;
  style "T"
case m.icon=2
 @ 1.154,1.800 say (locfile("question.bmp","BMP|ICO", "Where is Question?")) bitmap ;
  size 2.769,7.200 ;
  style "T"
case m.icon=3
 @ 1.154,1.800 say (locfile("exclaim.bmp","BMP|ICO", "Where is Exclaim?")) bitmap ;
  size 2.769,7.200 ;
  style "T"
case m.icon=4
 @ 1.154,1.800 say (locfile("info.bmp","BMP|ICO", "Where is Info?")) bitmap ;
  size 2.769,7.200 ;
  style "T"
endcase

do case					
case m.b_type=0
 if read_ok							&& if rdlevel()<5 use buttons and read cycle modal
  @ 5.923,24.800 get m.button picture "@*HT Ok" ;
   size 1.769,11.500,1.667 default 1 ;
   font fontname, 8 style "B"
 else								&& otherwise use inkey() and capture key press
  hotkey='O'
  @ 6.231,28.800 say "(O)k" font fontname, 10 ;
   style "BT"
 endi
case m.b_type=1
 if read_ok
  @ 5.923,17.000 get m.button picture "@*HT Ok;Cancel" ;
   size 1.769,11.500,1.667 default 1 ;
   font fontname, 8 style "B"
 else
  hotkey='OC'
  @ 6.231,21.600 say "(O)k" font fontname, 10 ;
   style "BT"
  @ 6.231,31.200 say "(C)ancel" font fontname, 10 ;
   style "BT"
 endi
case m.b_type=2
 if read_ok
  @ 5.923,9.000 get m.button picture "@*HT Abort;Retry;Ignore" ;
   size 1.769,11.500,1.667 default 1 ;
   font fontname, 8 style "B"
 else
  hotkey='ARI'
  @ 6.231,14.400 say "(A)bort" font fontname, 10 ;
   style "BT"
  @ 6.231,28.800 say "(R)etry" font fontname, 10 ;
   style "BT"
  @ 6.231,43.200 say "(I)gnore" font fontname, 10 ;
   style "BT"
 endi
case m.b_type=3
 if read_ok
  @ 5.923,9.000 get m.button picture "@*HT Yes;No;Cancel" ;
   size 1.769,11.500,1.667 default 1 ;
   font fontname, 8 style "B"
 else
  hotkey='YNC'
  @ 6.231,16.800 say "(Y)es" font fontname, 10 ;
   style "BT"
  @ 6.231,28.800 say "(N)o" font fontname, 10 ;
   style "BT"
  @ 6.231,40.800 say "(C)ancel" font fontname, 10 ;
   style "BT"
 endif
case m.b_type=4
 if read_ok
  @ 5.923,17.000 get m.button picture "@*HT Yes;No" ;
   size 1.769,11.500,1.667 default 1 ;
   font fontname, 8 style "B"
 else
  hotkey='YN'
  @ 6.231,24.000 say "(Y)es" font fontname, 10 ;
   style "BT"
  @ 6.231,36.000 say "(N)o" font fontname, 10 ;
   style "BT"
 endif
case m.b_type=5
 if read_ok
  @ 5.923,17.000 get m.button picture "@*HT Retry;Cancel" ;
   size 1.769,11.500,1.667 default 1 ;
   font fontname, 8 style "B"
 else
  hotkey='RC'
  @ 6.231,21.600 say "(R)etry" font fontname, 10 ;
   style "BT"
  @ 6.231,36.000 say "(C)ancel" font fontname, 10 ;
   style "BT"
 endi
endcase

@ 1.000,11.800 say msg size 4.000,39.333 font fontname, 8 ;
 style "B"

if not wvisible("msgbox")
 activate window msgbox
endif

if read_ok					&& if rdlevel()<5 use read command
 read cycle modal
else						&& otherwise use inkey()
 do while .t.
  keypress=inkey(0,'H')
  if upper(chr(abs(keypress)))$hotkey && use ABS() since function keys can return -ve numbers
   m.button=upper(chr(keypress))
   exit
  endif
 enddo
endif

do case
case left(m.button,1)='O'
 retvalue=1
case left(m.button,1)='C'
 retvalue=2
case left(m.button,1)='A'
 retvalue=3
case left(m.button,1)='R'
 retvalue=4
case left(m.button,1)='I'
 retvalue=5
case left(m.button,1)='Y'
 retvalue=6
case left(m.button,1)='N'
 retvalue=7
endcase

release window msgbox
pop key
return retvalue
